function ABS(atom n)
  if n<0 then
    return(-n)
  else
    return(n)
  end if
end function

global function Patrec_choose(sequence pattern,sequence TABLE)
  sequence arena
  integer maxsituations,choice,maxchoices
  maxsituations=length(pattern)
  choice=1
  arena=repeat(0,maxsituations)
  maxchoices=length(TABLE)
  bk_color(6)
  text_color(0)

  for action=1 to maxchoices do
    for situation = 1 to maxsituations  do
      arena[action]+=TABLE[action][situation]*pattern[situation]
      position(situation+1,action*6+33)
      printf(1,"%6d",TABLE[action][situation])
    end for
    position(12,action*6+33)
    printf(1,"%6d",arena[action])
  end for
  --that sets the column totals, now choose the maximum. column 1 is choice 1 etc.
  for action=1 to maxchoices do
    if arena[action]>arena[choice] then choice=action end if
  end for
  for k=1 to maxchoices do
    position(14,k*6+33)
    if choice=k then printf(1,"%6d",1)
    else puts(1,"     0")
    end if
  end for
  if ABS(arena[choice])>50000 then TABLE/=2  end if --prevents overflows
  return choice
end function

global function Patrec_learn(sequence information,sequence TABLE,integer choice,atom score)
  integer maxchoices,maxsituations
  maxsituations=length(information)
  maxchoices=length(TABLE)
    for action=1 to maxchoices do --for each column
      for situation = 1 to maxsituations do  --for each row
	if information[situation]=1 then
	  if action=choice then  --if true and chosen
	    TABLE[action][situation]+=score
	  else                   --if true and not chosen
	    TABLE[action][situation]-=score
	  end if
	else                     --if not true
	  if action=choice then  --and was chosen
	    TABLE[action][situation]-=score
	  else
	    TABLE[action][situation]+=score
	  end if
	end if
      end for
    end for
  return TABLE
end function

